--[[ MonkeyPirate ]]--

MonkeyPirate = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceComm-2.0", "AceHook-2.1");

local L = AceLibrary("AceLocale-2.2"):new("MonkeyPirate");

MonkeyPirate:RegisterDB("MonkeyPirateDB");

local ToChallengeTable = { };
local MAX_ENTRIES = 0;
local function countTable(t) local i=0; for k,v in pairs(t) do i = i + 1; end return i; end;
local buttons = { };
local DISPLAY_MAX_ENTRIES = 7;

function MonkeyPirate:OnInitialize()
	self:SetCommPrefix("MonkeyPirate");
	SLASH_PIRATEINSULT1 = "/pi";
	SLASH_PIRATEINSULT2 = "/pinsult";
	SLASH_PIRATEINSULT3 = "/mp";
	SlashCmdList["PIRATEINSULT"] = function(args) MonkeyPirate:SlashCommandHandler(args); end;
	
	MAX_ENTRIES = countTable(MonkeyPirateInsults);
	
	local name = "MonkeyPirate_Question";
	
	self.frame = CreateFrame("Frame", name, UIParent);
	local frame = self.frame;
	
	frame:SetWidth(300);
	frame:SetHeight(400);
	frame:SetToplevel(1);
	frame:SetFrameStrata("HIGH");
	frame:SetPoint("CENTER");
	
	for i=0,DISPLAY_MAX_ENTRIES do
		buttons[i] = CreateFrame("Button", name .. "Button" .. i, frame);
		buttons[i].fontstring = buttons[i]:CreateFontString(name .. "Text" .. i, "OVERLAY", "TextStatusBar");
		local fontFile, unused, fontFlags = DEFAULT_CHAT_FRAME:GetFont();
		buttons[i].fontstring:SetFont(fontFile, 30, fontFlags);
		buttons[i]:SetFontString(buttons[i].fontstring)
		buttons[i]:SetTextColor(1.0, 1.0, 1.0, 1.0);
		buttons[i]:SetText("");
		buttons[i]:SetWidth(500);
		buttons[i]:SetHeight(40);
		if(i == 0) then
			buttons[i]:SetPoint("TOP", frame, "TOP");
		else
			buttons[i]:SetPoint("TOP", buttons[i-1], "BOTTOM");
		end
		buttons[i]:RegisterForClicks("LeftButtonUp");
		buttons[i]:SetScript("OnClick", self.OnClick);
		buttons[i]:Show();
	end
	self.frame.buttons = buttons;
	frame:Hide();
end

function MonkeyPirate:OnEnable()
	self:RegisterComm(self.commPrefix, "WHISPER", "ReceiveMessage");
  
	self:SecureHook("UnitPopup_OnClick");
	UnitPopupButtons["MONKEY_PIRATE"] = { text = "Move outta the way, or I cuts my way through!", dist = 0 };
	tinsert(UnitPopupMenus["PLAYER"], #UnitPopupMenus["PLAYER"]-1, "MONKEY_PIRATE");  
end

function MonkeyPirate:OnDisable()
	self:UnregisterComm(self.commPrefix, "WHISPER");
end

function MonkeyPirate:ReceiveMessage(prefix, sender, distribution, command, text)
	if(command == "REQUESTCHALLENGE" and text == nil) then
		local dialog = StaticPopup_Show("MONKEYPIRATE_CHALLENGE_QUESTION");
		getglobal(dialog:GetName() .. "Text"):SetText(format(L["My name is %s. Prepare to die."], sender));
		if(dialog) then
			dialog.data = sender;
		end
	elseif(command == "ACCEPTCHALLENGE") then
		self:ChooseInsult(sender);
	elseif(command == "QUESTION") then
		self:ShowQuestion(sender, text);
	elseif(command == "ANSWER") then
		if(text == MonkeyPirateInsults[self.frame.InsultChosen]) then
			self:Print("The other pirate laughs about you and goes away!");
			self:SendCommMessage("WHISPER", sender, "YOUWON");
		else
			self:Print("You laugh at the pirate and go away!");
			self:SendCommMessage("WHISPER", sender, "YOULOST");
		end
		self.frame.InsultChosen = "";
	elseif(command == "YOUWON") then
		self:Print("You laugh at the pirate and go away!");
	elseif(command == "YOULOST") then
		self:Print("The other pirate laughs about you and goes away!");
	end
	
	-- todo: stats, cheating detection
end

function MonkeyPirate:UnitPopup_OnClick()
	local frame = getglobal(UIDROPDOWNMENU_INIT_MENU);
	local button = this.value;
	
	if(this.value == "MONKEY_PIRATE") then
		local target = UnitName("target");
		if(target ~= nil) then
			self:RequestChallenge(target);
		end
	end
end

local function GetNumberToInsult(insult)
		local i = 0;
		for k,v in pairs(MonkeyPirateInsults) do
			if(k == insult) then
				return i;
			end
			i = i + 1;
		end
	end

local function GetNumberToAnswer(answer)
	local i = 0;
	for k,v in pairs(MonkeyPirateInsults) do
		if(v == text) then
			return i;
		end
	end
	return -1;
end

local function GetInsultToNumber(number)
		local i = 0;
		for k,v in pairs(MonkeyPirateInsults) do
			if(i == number) then
				return k;
			end
			i = i + 1;
		end
	end

local function GetAnswerToNumber(number)
		local i = 0;
		for k,v in pairs(MonkeyPirateInsults) do
			if(i == number) then
				return v;
			end
			i = i + 1;
		end
	end

local function IsInArray(array, number)
			for k,v in pairs(array) do 
				if(v == number) then
					return true;
				end
			end
			return false;
	  end;

function MonkeyPirate:OnClick()
	if(arg1 == "LeftButton") then
		if(MonkeyPirateInsults[self:GetText()] ~= nil) then
			MonkeyPirate:SendCommMessage("WHISPER", self.receiver, "QUESTION", self:GetText());
			MonkeyPirate.frame.InsultChosen = self:GetText();
			MonkeyPirate.frame:Hide();
		else
			MonkeyPirate:CancelScheduledEvent("AnswerTimeout");
			MonkeyPirate:SendCommMessage("WHISPER", self.receiver, "ANSWER", self:GetText());
			MonkeyPirate.frame:Hide();
		end
	end
end

function MonkeyPirate:ShowQuestion(sender, text)
	buttons[0]:SetTextColor(1.0, 0.5, 0.5, 1.0);
	buttons[0]:SetText(text);
	buttons[0]:Disable();

	local chosenNumbers = { }
	local correctNumber = GetNumberToInsult(text);
	
	if(correctNumber == -1) then
		self:Print("Error - unknown question");
		return;
	end
	tinsert(chosenNumbers, correctNumber);
	self:Print(correctNumber, GetAnswerToNumber(correctNumber));
	self.frame.correctAnswer = GetAnswerToNumber(correctNumber);
	
	while(#chosenNumbers < #buttons - 2) do
		local number = random(MAX_ENTRIES - 1);
		while(IsInArray(chosenNumbers, number)) do 
			number = random(MAX_ENTRIES - 1);
		end
		tinsert(chosenNumbers, number);
	end

	-- randomize entry 0 with other entry
	local randomNumber = random(#chosenNumbers - 1);
	temp = chosenNumbers[randomNumber];
	chosenNumbers[randomNumber] = chosenNumbers[0];
	chosenNumbers[0] = temp;
	
	local i = 1;
	for k,v in pairs(chosenNumbers) do
		local answer = GetAnswerToNumber(v);
		buttons[i]:SetText(answer);
		buttons[i]:SetTextColor(1.0, 1.0, 1.0, 1.0);
		buttons[i].receiver = sender;
		buttons[i]:Enable();
		i = i + 1;
	end
	buttons[#buttons-1]:SetText(MonkeyPirateOther[random(#MonkeyPirateOther-1)]);
	buttons[#buttons-1]:Enable();
	buttons[#buttons-1]:SetTextColor(1.0, 1.0, 1.0, 1.0);
	buttons[#buttons-1].receiver = sender;
	
	self.frame:Show();
	self:ScheduleEvent("AnswerTimeout", function()
							self.frame:Hide();
							MonkeyPirate:SendCommMessage("WHISPER", MonkeyPirate.frame.buttons[1].receiver, "ANSWER", "TIMEOUT");
						end, 5);
end

function MonkeyPirate:ChooseInsult(player)
	local chosenNumbers = { }
	local number = random(MAX_ENTRIES - 1);
	while(#chosenNumbers < #buttons)  do
		-- will deadlock if not enough entries
		while(IsInArray(chosenNumbers, number)) do 
			number = random(MAX_ENTRIES - 1);
		end
		tinsert(chosenNumbers, number);
	end
	local i = 0;

	for k,v in pairs(chosenNumbers) do
		buttons[i]:SetText(GetInsultToNumber(v));
		buttons[i]:Enable();
		buttons[i]:SetTextColor(1.0, 1.0, 1.0, 1.0);
		buttons[i].receiver = player;
		i = i + 1;
	end
	
	self.frame:Show();
end

function MonkeyPirate:SlashCommandHandler(args)
	command = string.trim(args);
	if(args == nil or args == "") then
		self:Print(L["Usage: <playername>"]);
		return;
	end
	
	self:RequestChallenge(command)
end

function MonkeyPirate:RequestChallenge(player)
	-- "My name is Guybrush Threepwood. Prepare to die. -- Challenge
  
	self:SendCommMessage("WHISPER", player, "REQUESTCHALLENGE");
	-- timeout
	--tinsert(ToChallengeTable, args);
end

function MonkeyPirate:AcceptChallenge(player)
	self:SendCommMessage("WHISPER", player, "ACCEPTCHALLENGE", "Prepare to die!");
end

StaticPopupDialogs["MONKEYPIRATE_CHALLENGE_QUESTION"] = {
	text = "TEMPLATE",
	button1 = L["Prepare to die"],
	button2 = L["Behind you!"],
	OnAccept = function()
		local dialog = this:GetParent();
		
		MonkeyPirate:AcceptChallenge(dialog.data);
	end,
	OnHide = function()
		if(ChatFrameEditBox:IsVisible() ) then
			ChatFrameEditBox:SetFocus();
		end
	end,
	timeout = 10,
	whileDead = 1,
	hideOnEscape = 1
}

-- My name is Guybrush Threepwood, Prepare to die
-- 
